#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "mapresult4xi.py">
#<abstract4xi abstract = "provides class MapResult"/>
#<refer4xi reference = "pool.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'MapResult4Xi' ] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    import queue                    
    import itertools
    import time         
except:
    pass
try:                 # rare ones
    import collections          
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.pool import MapResult
except:
    print("mapresult4xi.py *** failed in from multiprocessing.pool import MapResult ***")
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from applyresult4xi import ApplyResult4Xi
import constant_family4xi
import constant_heap4xi
import constant_pool4xi
import constant_synchronize4xi
import constant_system4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from print4xi import print4xi
from time4xi import time4xi
#"
#/>



# =================================================================================================
#<class4xi class = "MapResult4Xi" base = "ApplyResult4Xi" child = "None" synopsis = "sets object result" usage = "
#   pool.py
#       map_asyn:
#          result = MapResult(self._cache, chunksize, len(iterable), callback)"
#   applyresult4xi.py:
#       result2xi = MapResult4Xi(self._cache, chunksize, len(iterable), callback)
#   pool4xi.py:
#       result2xi = MapResult4Xi(self._cache, chunksize, len(iterable), callback)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class MapResult4Xi(ApplyResult4Xi):
    '''
    sets object result
    '''
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('sense', 'reason', 'ace')          
    #"
    #/>
                                                                                                                                                               
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-MapResult4Xi" usage = "initializes MapResult4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def __init__(self, cache, chunksize, length, callback, error_callback):
        '''
        initializes MapResult4Xi
        '''
   
        # -----------------------------------------------------------------------------------------    
        # (Step 1/7)
        # -----------------------------------------------------------------------------------------        
        
        class2print = "MapResult4Xi"
        method2print = "__init__"

        message2print = "{(Step 1/7a) started" + "; init-of-MapResult4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                                 
        message2print = "{(Step 1/7b) borning" + "; mapresult2xi-of-MapResult4Xi-borning: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                     
        message2print = "{(Step 1/7c) passed" + "; cache-passed-to-init-of-MapResult4Xi: " + str(cache) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                     
        message2print = "{(Step 1/7d) passed" + "; chunksize-passed-to-init-of-MapResult4Xi: " + str(chunksize) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                     
        message2print = "{(Step 1/7e) passed" + "; length-passed-to-init-of-MapResult4Xi: " + str(length) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                     
        message2print = "{(Step 1/7f) passed" + "; callback-passed-to-init-of-MapResult4Xi: " + str(callback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        
        message2print = "{(Step 1/7g) passed" + "; error_callback-passed-to-init-of-MapResult4Xi: " + str(error_callback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
   
        # -----------------------------------------------------------------------------------------    
        # (Step 2/7)
        # -----------------------------------------------------------------------------------------        
   
        message2print = "{(Step 2/7a) passing" + "; mapresult2xi-passing-to-ApplyResult4Xi-init-by-init-of-MapResult4Xi: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
                        
        message2print = "{(Step 2/7b) passing" + "; cache-passing-to-ApplyResult4Xi-init-by-init-of-MapResult4Xi: " + str(cache) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
           
                        
        message2print = "{(Step 2/7c) passing" + "; callback-passing-to-ApplyResult4Xi-init-by-init-of-MapResult4Xi: " + str(callback) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                                                          
        try:
            ApplyResult4Xi.__init__(self, cache, callback, error_callback=error_callback)

            message2print = "{(Step 2/7d) performed" + "; ApplyResult4Xi-init-performed-by-init-by-init-of-MapResult4Xi: " + str(ApplyResult4Xi.__init__) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
        except:
            message2print = "{(Step 2/7e) hit" + "; ApplyResult4Xi-init-hit-by-init-of-MapResult4Xi: " + " *** " + str(ApplyResult4Xi.__init__)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
                
                     
        # -----------------------------------------------------------------------------------------    
        # (Step 3/7)
        # -----------------------------------------------------------------------------------------                 
        
        self._success = True
        
        message2print = "{(Step 3/7) set" + "; success-of-mapresult2xi-set-by-init-of-MapResult4Xi to: " + str(self._success)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
   
        # -----------------------------------------------------------------------------------------    
        # (Step 4/7)
        # -----------------------------------------------------------------------------------------        
                           
        self._value = [None] * length
        
        message2print = "{(Step 4/7) set" + "; value-of-mapresult2xi-set-by-init-of-MapResult4Xi to: " + str(self._value)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
   
        # -----------------------------------------------------------------------------------------    
        # (Step 5/7)
        # -----------------------------------------------------------------------------------------        
              
        self._chunksize = chunksize
        
        message2print = "{(Step 5/7) set" + "; chunksize-of-mapresult2xi-set-by-init-of-MapResult4Xi to: " + str(self._chunksize)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
           
        # -----------------------------------------------------------------------------------------    
        # (Step 6/7)
        # -----------------------------------------------------------------------------------------                 
        
        if chunksize <= 0:
           
            # --------------------------------------------------------------------------------------    
            # 
            # --------------------------------------------------------------------------------------                 
              
            self._number_left = 0

            message2print = "{(Step 6/7a) set" + "; number-left-of-mapresult2xi-set-by-init-of-MapResult4Xi to: " + str(self._number_left)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
           
            # --------------------------------------------------------------------------------------    
            # 
            # --------------------------------------------------------------------------------------                 
                   
            self._event.set()

            message2print = "{(Step 6/7b) performed" + "; event-set-performed-by-init-of-MapResult4Xi: " + str(self._event.set)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            
            message2print = "{(Step 6/7c) deleting" + "; job-deleting-by-init-of-MapResult4Xi: " + str(cache[self._job])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            
            del cache[self._job]   
        else:
           
            # --------------------------------------------------------------------------------------    
            # 
            # --------------------------------------------------------------------------------------                 
            
            self._number_left = length//chunksize + bool(length % chunksize)

            message2print = "{(Step 6/7b) set" + "; number-of-mapresult2xi-left-set-by-init-of-MapResult4Xi to: " + str(self._number_left)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                
   
        # -----------------------------------------------------------------------------------------    
        # (Step 7/7)
        # -----------------------------------------------------------------------------------------        
                                       
        message2print = "{(Step 7/7a) activated" + "; mapresult2xi-of-MapResult4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                         
        message2print = "{(Step 7/7b) returning" + "; init-of-MapResult4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                                                    
    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-MapResult4Xi" usage = "sets with self, i, success_result">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # --------------------------------------------------------------------------------------------- 
    def _set(self, i, success_result):
        '''
        MapResult4Xi method _set: sets with self, i, success_result
        '''
   
        # -----------------------------------------------------------------------------------------    
        # (Step 1/17)
        # -----------------------------------------------------------------------------------------        
           
        class2print = "MapResult4Xi"
        method2print = "_set"

        message2print = "{(Step 1/17a) started" + "; set-of-MapResult4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        message2print = "{(Step 1/17b) passed" + "; index-passed-to-set-of-MapResult4Xi: " + str(i) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
  
        message2print = "{(Step 1/17c) passed" + "; success-result-passed-to-set-of-MapResult4Xi: " + str(success_result) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
   
        # -----------------------------------------------------------------------------------------    
        # (Step 2/17)
        # -----------------------------------------------------------------------------------------        
             
        success, result = success_result
        
        message2print = "{(Step 2/17a) set" + "; success-set-by-set-of-MapResult4Xi to: " + str(success)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        message2print = "{(Step 2/17b) set" + "; result-set-by-set-of-MapResult4Xi to: " + str(result)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                  
                        
        if success:
           
            # --------------------------------------------------------------------------------------    
            # (Step 3/17) 
            # --------------------------------------------------------------------------------------                 
            
            self._value[i*self._chunksize:(i+1)*self._chunksize] = result
            
            message2print = "{(Step 3/17) set" + "; value-of-mapresult2xi-set-by-set-of-MapResult4Xi to: " + str(self._value[i*self._chunksize:(i+1)*self._chunksize])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
                            
                            
           
            # --------------------------------------------------------------------------------------    
            # (Step 4/17) 
            # --------------------------------------------------------------------------------------                 
          
            self._number_left -= 1
            
            message2print = "{(Step 4/17a) set" + "; number-left-of-mapresult2xi-set-by-set-of-MapResult4Xi to: " + str(self._number_left)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
               
                     
            message2print = "{(Step 4/17b) checking" + "; number-left-of-mapresult2xi-checking-by-set-of-MapResult4Xi: " + str(self._number_left) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
                            
                   
            if self._number_left == 0:
                if self._callback:
           
                # ----------------------------------------------------------------------------------    
                # (Step 5/17)  
                # ----------------------------------------------------------------------------------                 
                    
                    message2print = "{(Step 5/17a) passing" + "; value-passing-to-callback-by-set-of-MapResult4Xi: " + str(self._value) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)            
                
                                
                    self._callback(self._value)
                
                    message2print = "{(Step 5/17b) performed" + "; callback-of-mapresult2xi-performed-by-set-of-MapResult4Xi: " + str(self._callback) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
           
                # ----------------------------------------------------------------------------------    
                # (Step 6/17) 
                # ----------------------------------------------------------------------------------                 
                     
                message2print = "{(Step 6/17) passing" + "; job-of-mapresult2xi-passing-to-del-by-set-of-MapResult4Xi: " + str(self._job) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                
                                       
                del self._cache[self._job]
           
                # ----------------------------------------------------------------------------------    
                # (Step 7/17) 
                # ----------------------------------------------------------------------------------                 
                self._event.set()
                
                message2print = "{(Step 7/17a) performed" + "; cond-of-mapresult2xi-acquire-performed-by-set-of-MapResult4Xi: " + str(self._cond.acquire) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             

        else:
           
            # --------------------------------------------------------------------------------------    
            # (Step 10/17) 
            # --------------------------------------------------------------------------------------                 
            
            self._success = False
            
            message2print = "{(Step 10/17) set" + "; success-of-mapresult2xi-set-by-set-of-MapResult4Xi to: " + str(self._success)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
           
            # --------------------------------------------------------------------------------------    
            # (Step 11/17) 
            # --------------------------------------------------------------------------------------                 
                 
            self._value = result
            
            message2print = "{(Step 11/17a) set" + "; value-of-mapresult2xi-set-by-set-of-MapResult4Xi to: " + str(self._value)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            
            if self._error_callback:
                
                message2print = "{(Step 11/17b) passing" + "; value-of-mapresult2xi-passing-to-error-callback-by-set-of-MapResult4Xi: " + str(self._value) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
           
                self._error_callback(self._value)

            # --------------------------------------------------------------------------------------    
            # (Step 12/17) 
            # --------------------------------------------------------------------------------------                 
                    
            message2print = "{(Step 12/17) deleting" + "; cache-job-of-mapresult2xi-deleting-by-MapResult4Xi: " + str(self._cache[self._job]) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
              
                                      
            del self._cache[self._job]
            
            # --------------------------------------------------------------------------------------    
            # (Step 13/17) 
            # --------------------------------------------------------------------------------------                 
            self._event.set()
            
            message2print = "{(Step 13/17) performed" + "; event-set-of-mapresult2xi-performed-by-set-of-MapResult4Xi: " + str(self._event.set) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             

        # -----------------------------------------------------------------------------------------    
        # (Step 17/17)
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 17/17) returning" + "; set-of-MapResult4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                           
    #</methodize4xi>
                    
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-MapResult4Xi" usage = "senses MapResult4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses MapResult4Xi class objects
        '''
   
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------        

        class2print = 'MapResult4Xi'
        method2print = 'sense'
        

        message2print = "{started" + "; sense-of-MapResult4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; MapResult4Xi-sensing-by-sense-of-MapResult4Xi: " + str(MapResult4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                  
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-MapResult4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['success-of-mapresult2xi'] = self._success 
            kb2xi['value-of-mapresult2xi'] = self._value         
            kb2xi['chunksize-of-mapresult2xi'] = self._chunksize 
            kb2xi['number-left-of-mapresult2xi'] = self._number_left          
            kb2xi['ready-of-mapresult2xi'] = self._ready 
            kb2xi['callback-of-mapresult2xi'] = self._callback         
            kb2xi['job-of-mapresult2xi'] = self._job 
            kb2xi['cache-of-mapresult2xi'] = self._cache   
            kb2xi['cond-acquire-of-mapresult2xi'] = self._cond.acquire  
            kb2xi['cond-notify-of-mapresult2xi'] = self._cond.notify   
            kb2xi['cond-release-of-mapresult2xi'] = self._cond.release          
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-MapResult4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
                      
        message2print = "{sensed" + "; MapResult4Xi-sensed-by-sense-of-MapResult4Xi: " + str(MapResult4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-MapResult4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                              
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-MapResult4Xi" usage = "reasons MapResult4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons MapResult4Xi class objects
        '''
   
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------        
          
        
        class2print = 'MapResult4Xi'
        method2print = 'reason'


        message2print = "{started" + "; reason-of-MapResult4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; MapResult4Xi-reasoning-by-reason-of-MapResult4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-MapResult4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------          
        try:
            if self._job is not None:
                kb4xi['job-of-mapresult2xi'] = self._job           
        except:
            message2print = "{yielded" + "; kb4xi-yielded-by-reason-of-MapResult4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
       
          
        
        message2print = "{reasoned" + "; MapResult4Xi-reasoned-by-reason-of-MapResult4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-MapResult4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-MapResult4Xi" usage = "aces MapResult4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        aces MapResult4Xi class objects 
        '''
   
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------        
   
        
        
        class2print = 'MapResult4Xi'
        method2print = 'ace'
        

        message2print = "{started" + "; ace-of-MapResult4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; MapResult4Xi-acing-by-ace-of-MapResult4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-MapResult4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------              
        try:
            if self._job is not None:
                kb8xi['cache-job-of-mapresult2xi'] = self._cache[self._job]         
        except:
            message2print = "{yielded" + "; kb8xi-yielded-by-ace-of-MapResult4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
          
        message2print = "{aced" + "; MapResult4Xi-aced-by-ace-of-MapResult4Xi: " + str(MapResult4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-MapResult4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of mapresult4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

 